package nccloud.api.riart.output;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.common.RuntimeEnv;
import nc.riart.pub.print.utils.GlConvertPdfUtils;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.gl.pubvoucher.VoucherVO;
import nccloud.api.riart.utils.BillPdfDataSource;

import java.io.File;
import java.io.InputStream;
import java.util.List;
import java.util.Map;

public  class PrintPdfOutputServlet {
    public Class<VoucherVO> getAggVOClz() {
        return VoucherVO.class;
    }

    public PrintPdfOutputServlet() {
    }

    String homepath = RuntimeEnv.getInstance().getNCHome();
    BaseDAO dao = new BaseDAO();
    GlConvertPdfUtils convertPdfUtils = new GlConvertPdfUtils();

    public PrintPdfOutputServlet(String homepath) {
        this.homepath = homepath;
    }
    public String getExportPdfInputStream(String cuserid, String pk_group, String billId, String ctemplateId) throws DAOException {
        InputStream in = null;
        String qrysql = "select * from gl_voucher where nvl(dr,0)=0 and pk_voucher = '"+billId+"'";
        VoucherVO vo = (VoucherVO) dao.executeQuery(qrysql,new BeanProcessor(VoucherVO.class));
        String qrydetail = "select * from gl_detail where nvl(dr,0)=0 and pk_voucher = '"+billId+"'";
        List<Map<String, String>> map = (List<Map<String, String>>) dao.executeQuery(qrydetail,new MapListProcessor());

        BillPdfDataSource printDS = new BillPdfDataSource(vo,map);
        String filepath = homepath+ File.separator+"exportPDF";
        File folder = new File(filepath);
        if(!folder.exists() && !folder.isDirectory()){
            folder.mkdirs();
        }
        String FileName = filepath + File.separator + billId + ".pdf";

        try {
            convertPdfUtils.pdfExport(ctemplateId,FileName,printDS);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return FileName;
    }
}
